From 498628d16a769132fe68c95f259c3bb557aab7e9 Mon Sep 17 00:00:00 2001
From: Takashi Yoshi <takashi@yoshi.email>
Date: Fri, 7 Dec 2018 19:02:43 +0100
Subject: [PATCH] [type/__package_pkg_openbsd] Misc. fixes and improvements

---
 .../__package_pkg_openbsd/explorer/pkg_state  | 49 +++++++++++++++++++
 .../explorer/pkg_version                      |  3 +-
 .../type/__package_pkg_openbsd/gencode-remote | 12 ++---
 3 files changed, 55 insertions(+), 9 deletions(-)
 create mode 100755 cdist/conf/type/__package_pkg_openbsd/explorer/pkg_state

diff --git a/cdist/conf/type/__package_pkg_openbsd/explorer/pkg_state b/cdist/conf/type/__package_pkg_openbsd/explorer/pkg_state
new file mode 100755
index 00000000..9cd17787
--- /dev/null
+++ b/cdist/conf/type/__package_pkg_openbsd/explorer/pkg_state
@@ -0,0 +1,49 @@
+#!/bin/sh
+#
+# Copyright 2018, Takashi Yoshi <takashi@yoshi.email>
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see <http://www.gnu.org/licenses/>.
+#
+#
+# Retrieve the status of a package - parsed pkg_info output
+#
+
+if [ -f "${__object}/parameter/name" ]
+then
+	pkgid="$(cat "${__object}/parameter/name")"
+else
+	pkgid="${__object_id}"
+fi
+
+if [ -f "${__object}/parameter/version" ]
+then
+	pkgid="${pkgid}-$(cat "${__object}/parameter/version")"
+fi
+
+if [ -f "${__object}/parameter/flavor" ]
+then
+	# If a flavor but no version is given we need to add another -,
+	# otherwise pkg_info confuses the flavor with the version.
+	[ -f "${__object}/parameter/version" ] || pkgid="${pkgid}-"
+
+	pkgid="${pkgid}-$(cat "${__object}/parameter/flavor")"
+fi
+
+
+pkg_info -q -I "inst:${pkgid}" >/dev/null 2>&1 \
+	&& echo 'present' || echo 'absent'
+
+exit 0
diff --git a/cdist/conf/type/__package_pkg_openbsd/explorer/pkg_version b/cdist/conf/type/__package_pkg_openbsd/explorer/pkg_version
index 71fccb42..9b51a588 100755
--- a/cdist/conf/type/__package_pkg_openbsd/explorer/pkg_version
+++ b/cdist/conf/type/__package_pkg_openbsd/explorer/pkg_version
@@ -2,6 +2,7 @@
 #
 # 2011 Andi Brönnimann (andi-cdist at v-net.ch)
 # Copyright 2017, Philippe Gregoire <pg@pgregoire.xyz>
+# Copyright 2018, Takashi Yoshi <takashi@yoshi.email>
 #
 # This file is part of cdist.
 #
@@ -19,7 +20,7 @@
 # along with cdist. If not, see <http://www.gnu.org/licenses/>.
 #
 #
-# Retrieve the status of a package - parsed pkg_info output
+# Retrieve the version of a package - parsed pkg_info output
 #
 
 if [ -f "$__object/parameter/name" ]; then
diff --git a/cdist/conf/type/__package_pkg_openbsd/gencode-remote b/cdist/conf/type/__package_pkg_openbsd/gencode-remote
index a189eeac..0a79fca3 100755
--- a/cdist/conf/type/__package_pkg_openbsd/gencode-remote
+++ b/cdist/conf/type/__package_pkg_openbsd/gencode-remote
@@ -2,6 +2,7 @@
 #
 # 2011 Andi Brönnimann (andi-cdist at v-net.ch)
 # 2012 Nico Schottelius (nico-cdist at schottelius.org)
+# 2018 Takashi Yoshi <takashi@yoshi.email>
 #
 # This file is part of cdist.
 #
@@ -72,12 +73,7 @@ else
   fi
 fi                                                                              
 
-if [ "$pkg_version" ]; then
-    state_is="present"
-else
-    state_is="absent"
-fi
-
+state_is="$(cat "$__object/explorer/pkg_state")"
 [ "$state_is" = "$state_should" ] && exit 0
 
 case "$state_should" in
@@ -88,7 +84,7 @@ if [ X != X"${pkg_path}" ]; then
     PKG_PATH="${pkg_path}"; export PKG_PATH
 fi
 status=\$(pkg_add "$pkgopts" "$pkgid" 2>&1)
-pkg_info | grep "^${name}.*${version}.*${flavor}" > /dev/null 2>&1
+pkg_info -q -I "inst:$pkgid" | grep -q "^${name}-${version}.*${flavor}$" 2>/dev/null
 
 # We didn't find the package in the list of 'installed packages', so it failed
 # This is necessary because pkg_add doesn't return properly
@@ -106,7 +102,7 @@ eof
         # use this because pkg_add doesn't properly handle errors
         cat << eof
 status=\$(pkg_delete "$pkgopts" "$pkgid")
-pkg_info | grep "^${name}.*${version}.*${flavor}" > /dev/null 2>&1
+pkg_info -q -I "inst:$pkgid" | grep -q "^${name}-${version}.*${flavor}" 2>/dev/null
 
 # We found the package in the list of 'installed packages'
 # This would indicate that pkg_delete failed, send the output of pkg_delete